<?xml version="1.0" encoding="utf-8"?>
<!-- An XSL style sheet for creating TSTP representations from OMDoc
     Initial version 20051025 Juergen Zimmer, 
     send bug-reports, patches, suggestions to omdoc@mathweb.org

     Copyright (c) 2005 Juergen Zimmer

     This library is free software; you can redistribute it and/or
     modify it under the terms of the GNU Lesser General Public
     License as published by the Free Software Foundation; either
     version 2.1 of the License, or (at your option) any later version.

     This library is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     Lesser General Public License for more details.

     You should have received a copy of the GNU Lesser General Public
     License along with this library; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<xsl:stylesheet 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:om="http://www.openmath.org/OpenMath"
  xmlns:omdoc="http://www.mathweb.org/omdoc"
  version="1.0">

  <xsl:strip-space elements="*"/>

  <xsl:output method="text"/>

<!--   <xsl:template match="*"> -->
<!--     <xsl:message> -->
<!--       cannot deal with case <xsl:value-of select="local-name()"/> yet! -->
<!--     </xsl:message> -->
<!--   </xsl:template> -->

  <xsl:template match="omdoc:CMP"/>

  <xsl:template match="/">
    <xsl:text>% This file is automatically generated from OMDoc, do not edit&#xA;&#xA;</xsl:text>
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="omdoc:omdoc">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="omdoc:theory|omdoc:FMP|om:OMOBJ|omdoc:conclusion">
    <xsl:apply-templates/>
  </xsl:template>

  <!-- ******** type information here ********* -->
  <xsl:template match="omdoc:symbol"/>

  <xsl:template match="omdoc:assertion">
    <xsl:text>fof('</xsl:text>
    <xsl:value-of select="translate(@xml:id, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ-', 'abcdefghijklmnopqrstuvwxyz_')"/>
<!--     <xsl:value-of select="@xml:id"/> -->
    <xsl:text>', conjecture, (&#xA; </xsl:text>
    <xsl:apply-templates/>
    <xsl:text>)).&#xA;&#xA;</xsl:text>
  </xsl:template>

  <xsl:template match="omdoc:definition|omdoc:axiom">
    <xsl:text>fof('</xsl:text>
    <xsl:value-of select="translate(@xml:id, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ-', 'abcdefghijklmnopqrstuvwxyz_')"/>
<!--     <xsl:value-of select="@xml:id"/> -->
    <xsl:text>', axiom, (&#xA;  </xsl:text>
<!--     <xsl:variable name="ombind"  -->
<!--       select="omdoc:FMP/om:OMOBJ/om:OMBIND[om:OMS[position()=1 and  -->
<!--                                                   @cd='fns1' and  -->
<!--                                                   @name='lambda']]"/> -->
<!--     <xsl:choose> -->
<!--       <xsl:when test="$ombind"> -->
<!--         <xsl:text>![</xsl:text> -->
<!--         <xsl:for-each select="$ombind/*[2]/*"> -->
<!--           <xsl:apply-templates select="."/> -->
<!--           <xsl:if test="position() != last()"><xsl:text>,</xsl:text></xsl:if> -->
<!--         </xsl:for-each> -->
<!--         <xsl:text>]: equal(</xsl:text> -->
<!--         <xsl:value-of select="@for"/> -->
<!--         <xsl:text>(</xsl:text> -->
<!--         <xsl:for-each select="$ombind/*[2]/*"> -->
<!--           <xsl:apply-templates select="."/> -->
<!--           <xsl:if test="position() != last()"><xsl:text>,</xsl:text></xsl:if> -->
<!--         </xsl:for-each> -->
<!--         <xsl:text>),</xsl:text> -->
<!--         <xsl:apply-templates select="$ombind/*[3]"/> -->
<!--         <xsl:text>)</xsl:text> -->
<!--       </xsl:when> -->
<!--       <xsl:otherwise><xsl:apply-templates/></xsl:otherwise> -->
<!--     </xsl:choose> -->
       <xsl:apply-templates/>
    <xsl:text>)).&#xA;&#xA;</xsl:text>
  </xsl:template>

<!-- ################ OpenMath ################-->

<xsl:template match="om:OMV">
  <xsl:value-of select="translate(@name, 'abcdefghijklmnopqrstuvwxyz' , 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
<!--   <xsl:call-template name="normalise-name"> -->
<!--      <xsl:with-param name="name" select="@name"/> -->
<!--   </xsl:call-template> -->
</xsl:template>

<xsl:template match="om:OMS[@name='Eq' and @cd='hol']">
  <xsl:text>=</xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='=' and @cd='hol']">
  <xsl:text>=</xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='Impl' and @cd='hol']">
  <xsl:text>=></xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='Eqv' and @cd='hol']">
  <xsl:text>&lt;=></xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='And' and @cd='hol']">
  <xsl:text>&amp;</xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='Or' and @cd='hol']">
  <xsl:text>|</xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='Not' and @cd='hol']">
  <xsl:text>~</xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='Eq' and @cd='CORE']">
  <xsl:text>=</xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='=' and @cd='CORE']">
  <xsl:text>=</xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='Impl' and @cd='CORE']">
  <xsl:text>=></xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='Eqv' and @cd='CORE']">
  <xsl:text>&lt;=></xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='And' and @cd='CORE']">
  <xsl:text>&amp;</xsl:text>
</xsl:template>

<xsl:template match="om:OMS[@name='Or' and @cd='CORE']">
  <xsl:text>|</xsl:text>
</xsl:template>



<xsl:template match="om:OMS">
  <xsl:value-of select="translate(@name, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ-', 'abcdefghijklmnopqrstuvwxyz_')"/>
<!--   <xsl:value-of select="@name"/> -->
<!--   <xsl:call-template name="normalise-name"> -->
<!--      <xsl:with-param name="name" select="@name"/> -->
<!--   </xsl:call-template> -->
<!--   <xsl:value-of select="translate(@name, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')"/> -->
</xsl:template>

<xsl:template match="om:OMBVAR">
  <xsl:value-of select="@name"/>
<!--   <xsl:call-template name="normalise-name"> -->
<!--      <xsl:with-param name="name" select="@name"/> -->
<!--   </xsl:call-template> -->
<!--   <xsl:value-of select="translate(@name, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')"/> -->
</xsl:template>

<xsl:template match="om:OMI"><xsl:value-of select="."/><xsl:text> </xsl:text></xsl:template>

<!-- <xsl:template match="om:OMBIND[om:OMS[@name='all-types' and @cd='POST']]"> -->
<!--   <xsl:text>(all-types </xsl:text> -->
<!--     <xsl:apply-templates select="om:OMBVAR/*"/> -->
<!--     <xsl:apply-templates select="*[3]"/> -->
<!--   <xsl:text>)</xsl:text> -->
<!-- </xsl:template> -->

<xsl:template name="lambda">
  <xsl:param name="quantor"/>
  <xsl:param name="varlist"/>
  <xsl:param name="body"/>
  <xsl:value-of select="$quantor"/>
  <xsl:text> [</xsl:text>
    <xsl:for-each select="$varlist">
      <xsl:apply-templates select="."/>
      <xsl:if test="position()!=last() and position()!=1">
        <xsl:text>, </xsl:text>
      </xsl:if>
     </xsl:for-each>
    <xsl:text>] :&#xa; (</xsl:text>
<!--   <xsl:text>&#xa;</xsl:text> -->
  <xsl:apply-templates select="$body" />
  <xsl:text>)</xsl:text>
</xsl:template>


<xsl:template match="om:OMA[om:OMS[@name='PI' and @cd='hol']]">
  <!-- [om:OMBIND[om:OMS[@name='lambda' and @cd='fns1']]] -->
  <xsl:for-each select="om:OMBIND[om:OMS[@name='lambda' and @cd='fns1']]">
<!--     <xsl:call-template name="lambda"> -->
<!--       <xsl:with-param name="quantor" select="'forall'"/> -->
<!--       <xsl:with-param name="varlist" select="om:OMBVAR/*"/> -->
<!--       <xsl:with-param name="body" select="*[3]"/> -->
<!--     </xsl:call-template> -->
    <xsl:call-template name="lambda">
      <xsl:with-param name="quantor" select="'!'"/>
      <xsl:with-param name="varlist" select="om:OMBVAR/om:OMV|om:OMBVAR/om:OMATTR/om:OMV"/>
      <xsl:with-param name="body" select="*[3]"/>
    </xsl:call-template>
  </xsl:for-each>
</xsl:template>

<xsl:template match="om:OMA[om:OMS[@name='Not' and @cd='hol']]">
  <xsl:apply-templates select="*[1]"/>  
  <xsl:text>(</xsl:text>
    <xsl:for-each select="*">
      <xsl:if test="position()!=1">
        <xsl:apply-templates select="."/>
      </xsl:if>
      <xsl:if test="position()!=last() and position()!=1">
        <xsl:text>, </xsl:text>
      </xsl:if>
    </xsl:for-each>
  <xsl:text>)</xsl:text>
</xsl:template>


<xsl:template match="om:OMA[om:OMS[@name='Impl' and @cd='hol']]|om:OMA[om:OMS[@name='And' and @cd='hol']]|om:OMA[om:OMS[@name='Or' and @cd='hol']]|om:OMA[om:OMS[@name='Eqv' and @cd='hol']]|om:OMA[om:OMS[@name='Eq' and @cd='hol']]">
  <xsl:text>(</xsl:text>
    <xsl:apply-templates select="*[2]"/>  
    <xsl:text> </xsl:text>
    <xsl:apply-templates select="*[1]"/>  
    <xsl:text> </xsl:text>
    <xsl:apply-templates select="*[3]"/>  
  <xsl:text>)</xsl:text>
</xsl:template>

<xsl:template match="om:OMA[om:OMS[@name='PI' and @cd='CORE']]">
  <!-- [om:OMBIND[om:OMS[@name='lambda' and @cd='fns1']]] -->
  <xsl:for-each select="om:OMBIND[om:OMS[@name='lambda' and @cd='fns1']]">
<!--     <xsl:call-template name="lambda"> -->
<!--       <xsl:with-param name="quantor" select="'forall'"/> -->
<!--       <xsl:with-param name="varlist" select="om:OMBVAR/*"/> -->
<!--       <xsl:with-param name="body" select="*[3]"/> -->
<!--     </xsl:call-template> -->
    <xsl:call-template name="lambda">
      <xsl:with-param name="quantor" select="'!'"/>
      <xsl:with-param name="varlist" select="om:OMBVAR/om:OMV|om:OMBVAR/om:OMATTR/om:OMV"/>
      <xsl:with-param name="body" select="*[3]"/>
    </xsl:call-template>
  </xsl:for-each>
</xsl:template>

<xsl:template match="om:OMA[om:OMS[@name='Not' and @cd='CORE']]">
  <xsl:apply-templates select="*[1]"/>  
  <xsl:text>(</xsl:text>
    <xsl:for-each select="*">
      <xsl:if test="position()!=1">
        <xsl:apply-templates select="."/>
      </xsl:if>
      <xsl:if test="position()!=last() and position()!=1">
        <xsl:text>, </xsl:text>
      </xsl:if>
    </xsl:for-each>
  <xsl:text>)</xsl:text>
</xsl:template>


<xsl:template match="om:OMA[om:OMS[@name='Impl' and @cd='CORE']]|om:OMA[om:OMS[@name='And' and @cd='CORE']]|om:OMA[om:OMS[@name='Or' and @cd='CORE']]|om:OMA[om:OMS[@name='Eqv' and @cd='CORE']]|om:OMA[om:OMS[@name='=' and @cd='CORE']]">
  <xsl:text>(</xsl:text>
    <xsl:apply-templates select="*[2]"/>  
    <xsl:text> </xsl:text>
    <xsl:apply-templates select="*[1]"/>  
    <xsl:text> </xsl:text>
    <xsl:apply-templates select="*[3]"/>  
  <xsl:text>)</xsl:text>
</xsl:template>


<xsl:template match="om:OMA">
  <xsl:apply-templates select="*[1]"/>  
  <xsl:text>(</xsl:text>
  <xsl:for-each select="*">
    <xsl:if test="position()!=1">
      <xsl:apply-templates select="."/>
    </xsl:if>
    <xsl:if test="position()!=last() and position()!=1">
      <xsl:text>, </xsl:text>
    </xsl:if>
    </xsl:for-each>
    <xsl:text>)</xsl:text>
</xsl:template>


<xsl:template match="om:OMA[om:OMS[@name='funtype' and @cd='mltt']]">
<!--   <xsl:text>(</xsl:text> -->
    <xsl:apply-templates select="*[3]"/>
<!--     <xsl:text> </xsl:text> -->
<!--     <xsl:apply-templates select="*[2]"/> -->
<!--   <xsl:text>)</xsl:text> -->
</xsl:template>


  <xsl:template match="omdoc:metadata|omdoc:presentation|omdoc:example|omdoc:catalogue|omdoc:omtext|omdoc:CMP"/>
  
</xsl:stylesheet>
