// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathServe system

Authors: Juergen Zimmer

email: jzimmer@ags.uni-sb.de
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB Informatik                                            
Universitaet des Saarlandes                                          
Gebaeude E 1.1                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathServe, see 
http://www.ags.uni-sb.de/~jzimmer/mathserve.html

See the file "LICENSE.txt" or
http://www.ags.uni-sb.de/~jzimmer/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/

/** For testing:

For starting the perl XML-RPC server: 
  /usr/bin/perl -I/home/jzimmer/nb/Frontier-RPC-0.06/lib restartXMLRPC.pl > /home/jzimmer/restart.out

*/

package org.mathweb.util;

import java.util.Vector;

import org.apache.xmlrpc.*;


/**
   @author Juergen Zimmer, Saarland University, Germany
   @version $Date: 2006/08/24 13:40:27 $ $Revision: 1.2 $
*/
public class Restart {

  public static boolean restart()
  {
    try{
      String url = "http://hades.ags.uni-sb.de:12345/RPC2";
      XmlRpcClient connection = new XmlRpcClient(url);
      Object result = connection.execute("restart", new Vector());
      if (result.equals("restarted"))
        return true;
      else 
        return false;
    } catch (Exception e) {
      e.printStackTrace();
      return false; 
    }
  }
  
  /*  the name a TSTP file. */
  public static void main(String argv[]) throws Exception {
    Restart.restart();
  }
  
  
} // end Restart.java

      
/* Settings for Emacs.
 * Local variables:
 * c-basic-offset: 2
 * tab-width: 2
 * indent-tabs-mode: nil
 * End:
 */
