// -*- indent-tabs-mode: nil -*-
/*****************************************************************
This file is part of the MathServe system

Authors: Juergen Zimmer

email: jzimmer@ags.uni-sb.de
   
For information about this program, write to:                          
MathWeb-Project                                                        
AG Siekmann/FB Informatik                                            
Universitaet des Saarlandes                                          
Gebaeude E 1.1                                                     
D-66041 Saarbruecken                                                 
Germany    

For information about the newest version of MathServe, see 
http://www.ags.uni-sb.de/~jzimmer/mathserve.html

See the file "LICENSE.txt" or
http://www.ags.uni-sb.de/~jzimmer/LICENSE.html
for information on usage and redistribution
of this file, and for a DISCLAIMER OF ALL WARRANTIES.
*****************************************************************/
package org.mathweb.util;

import java.io.*;
import java.util.*;
import java.net.URI;

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.Namespace;
import org.jdom.JDOMException;
import org.jdom.xpath.XPath;
 
import org.mathweb.core.BasicService;
import org.mathweb.onto.OWLJDom;

/**
@author Juergen Zimmer, Saarland University, Germany
@version $Date: 2006/08/24 13:41:58 $ $Revision: 1.1 $
*/
public class SmtCreator extends BasicService {
//   private Quoter quoter = new Quoter();
  private static String xmlBase = "http://www.tptp.org/Problems#";
  private static OWLJDom owlJDom = OWLJDom.getInstance();
  
  //   public String smt2OWLSQuery(String smtProb) { 
  //     if (smtProb.indexOf("cnf(") > -1) 
//       return smt2OWLSQuery(smtProb, "cnf");
//     else
//       return smt2OWLSQuery(smtProb, "fof");
//   }
  
//   public String smt2OWLSQuery(String smtProb, String format) { 
//     try{
//       String name = "generated_smt_" + format + "_problem_"+System.currentTimeMillis();
//       //      System.out.println(name);
//       String tail = readFile(msHome + sep + "etc" + sep + "smt" + sep + "tptp-"+format+"-tail.xml");
//       String head = readFile(msHome + sep + "etc" + sep + "smt" + sep + "tptp-"+format+"-head.xml"); 
//       return head + name + "\">\n"+
//         //        "  <mw:formalDescription rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">\n" +
//         "  <mw:formalDescription rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">\n" +
//         quoter.quote(smtProb) +tail;
//     } catch(Exception e) {
//       return null;
//     }
//   }
  
//   public String smtFile2OWLSQuery(String smtFileName)
//   {
//     try{
//       File file = new File(smtFileName);
//       String name = file.getName().replace('-', '_');
//       //      System.out.println(name);
//       String smtProb = readFile(smtFileName);
//       String format = null;
//       if (smtFileName.indexOf("+") > -1) {
//         format = "fof";
//         name = name.replace('+', '_') + "_fof";
//       }
//       else format = "cnf";
//       name = name.replace('.', '_');
//       name = name + "_" + System.currentTimeMillis();
      
//       String tail = readFile(msHome + sep + "etc" + sep + "smt" + sep + "tptp-"+format+"-tail.xml");
//       String head = readFile(msHome + sep + "etc" + sep + "smt" + sep + "tptp-"+format+"-head.xml"); 
//       return head + name + "\">\n"+
//         "  <mw:formalDescription rdf:datatype=\"http://www.w3.org/2001/XMLSchema#string\">\n" +
//         quoter.quote(smtProb) +tail;
//     } catch(Exception e) {
//       return null;
//     }
//   }

  public String smt2OWLProblem(String smtFileName)
  {
    return smtFile2OWLProblem(new File(smtFileName));
  }
  

  public String smtFile2OWLProblem(File smtFile)
  {
    String probID = smtFile.getName();
    probID = probID.replace('-', '_').trim();
    probID = probID.replace('+', '_');
    //      System.out.println(probID);
    try{
      String smtProb = readFile(smtFile);
      return smtString2OWLProblem(smtProb, probID);
    } catch(Exception e){
      return null;
    }
  }
    
  public String smtString2OWLProblem(String smtProb, String probID)
  {
    try{ 
      Element rdf = new Element("RDF",  OWLJDom.RDF_NS);
      rdf.setAttribute("base", xmlBase, Namespace.XML_NAMESPACE);
      rdf.addNamespaceDeclaration(OWLJDom.MW_NS);
      Element prob = new Element("SmtProblem",OWLJDom.MW_NS);
      
      prob.setAttribute("ID", probID, OWLJDom.RDF_NS);
      Element formalProb = new Element("formalDescription",OWLJDom.MW_NS);
      formalProb.addContent(smtProb);
      //       Element probLogic = new Element("inLogic",OWLJDom.MW_NS); 
      //       probLogic.setAttribute("resource", "fol_plus_equ", OWLJDom.RDF_NS);
      
      prob.addContent(formalProb);
//       prob.addContent(probLogic);
      rdf.addContent(prob);
      return owlJDom.newXMLDocument(rdf);
      
    } catch(Exception e) {
      return null;
    }
  }
  
  public static void main(String[] args) {
    SmtCreator creat  = new SmtCreator();
    File file = new File(args[0]);
    String prob = creat.readFile(file); 
    String result= creat.smtString2OWLProblem(prob, "foo");
    System.out.println(result);
    System.exit(0);
  }
}

  
  
