//----Return 0 if this one's LISTNODE is marked or gets marked
int MarkACyclicAnnotatedFormulae(OptionsType OptionValues,LISTNODE Head,
TREENODE TreeRoot) {

    LISTNODE Target;
    int NumberOfUnmarkedParents;
    int ParentIndex;
//DEBUG String FormulaName;

//----Find this one in the list
//DEBUG ("searching for %s\n",GetName(TreeRoot->AnnotatedFormula,FormulaName));
    Target = Head;
    while (Target != NULL && Target->AnnotatedFormula != TreeRoot->
AnnotatedFormula) {
//DEBUG ("it's not %s\n",GetName(Target->AnnotatedFormula,FormulaName));
        Target = Target->Next;
    }
    if (Target == NULL) {
        CodingError("Tree node not in list");
    }

//----If listnode already marked, we're done
    if (Target->Visited == 2) {
//DEBUG ("already removed %s\n",GetName(Target->AnnotatedFormula,FormulaName));
        return(0);
    }

//----If list node previous in chain, error
    if (Target->Visited == 1) {
//DEBUG ("in a loop at %s\n",GetName(Target->AnnotatedFormula,FormulaName));
        return(1);
    }


//----Otherwise check if this one can be marked
    NumberOfUnmarkedParents = 0;
    for (ParentIndex = 0;ParentIndex < TreeRoot->NumberOfParents;
ParentIndex++) {
        Target->Visited = 1;
        NumberOfUnmarkedParents += MarkACyclicAnnotatedFormulae(OptionValues,
Head,TreeRoot->Parents[ParentIndex]);
    }
    if (NumberOfUnmarkedParents == 0) {
//DEBUG ("%s is parentless, mark\n",GetName(TreeRoot->AnnotatedFormula,FormulaName));
        Target->Visited = 2;
        return(0);
    } else {
//DEBUG ("%s has %d unmarked parents\n",GetName(TreeRoot->AnnotatedFormula,FormulaName),NumberOfUnmarkedParents);
        Target->Visited = 0;
        return(1);
    }
}
//-----------------------------------------------------------------------------
int ACyclic(OptionsType OptionValues,LISTNODE Head,ROOTLIST RootListHead) {

    int CycleFound;

    ResetListVisited(Head);

    CycleFound = 0;
    while (!CycleFound && RootListHead != NULL) {
        CycleFound = MarkACyclicAnnotatedFormulae(OptionValues,Head,
RootListHead->TheTree);
        RootListHead = RootListHead->Next;
    }

    ResetListVisited(Head);
    return(!CycleFound);
}
//-----------------------------------------------------------------------------
