//-----------------------------------------------------------------------------
int IsAxiomOfChoice(ANNOTATEDFORMULA AnnotatedFormula) {

//----At this stage no-one creates them, so skip the programming
    return(0);
}
//-----------------------------------------------------------------------------
int AllAxiomsOfChoicePresent(OptionsType OptionValues,LISTNODE Head,
SIGNATURE Signature) {

    int OKSoFar;
    LISTNODE Target;
    String FormulaName;
    int NumberOfParents;
    StringParts ParentNames;
    LISTNODE ParentAnnotatedFormulae;
    String SZSStatus;
    String InferenceRule;
    String AllParentNames;

    OKSoFar = 1;
    Target = Head;
    while (OKSoFar && Target != NULL) {
//----Crap check if it's Skolemization
        if (DerivedAnnotatedFormula(Target->AnnotatedFormula)) {
            GetInferenceRule(Target->AnnotatedFormula,InferenceRule);
            if (strcasestr(InferenceRule,"skolem") == InferenceRule) {
                GetInferenceStatus(Target->AnnotatedFormula,SZSStatus);
                GetName(Target->AnnotatedFormula,FormulaName);
//----Get the parents' in various ways
                GetNodeParentNames(Target->AnnotatedFormula,AllParentNames);
                NumberOfParents = Tokenize(AllParentNames,ParentNames,"\n");
                MakeListOfParents(OptionValues,Head,FormulaName,ParentNames,
NumberOfParents,&ParentAnnotatedFormulae);
//----If no axiom of choice then there's a problem
                if (NumberOfParents != 2 || strcmp(SZSStatus,"thm") ||
(!IsAxiomOfChoice(ParentAnnotatedFormulae->AnnotatedFormula) &&
!IsAxiomOfChoice((ParentAnnotatedFormulae->Next)->AnnotatedFormula))) {
                    if (OptionValues.ExpectIntroducedAxioms) {
                        OKSoFar = 0;
                        QPRINTF(OptionValues,2)(
"FAILURE: Skolemized formula %s has no axiom of choice parent\n",FormulaName);
                    } else {
                        QPRINTF(OptionValues,2)(
"WARNING: Skolemized formula %s has no axiom of choice parent\n",FormulaName);
                        AddVerifiedTag(Target->AnnotatedFormula,Signature,
"missing_axiom_of_choice");
                     }
                } 
//----Free the parents list
                FreeListOfAnnotatedFormulae(&ParentAnnotatedFormulae);
            }
        }
        Target = Target->Next;
    }

    return(OKSoFar);
}
//-----------------------------------------------------------------------------
int FindESplitDefn(LISTNODE Target,LISTNODE Head) {

    FORMULA TargetFormula;
    char * TargetPredicate;
    String PredicateDefined;

//----Expect the predicate to be defined to be LHS of disjunction
    TargetFormula = Target->AnnotatedFormula->AnnotatedFormulaUnion.
AnnotatedTSTPFormula.FormulaWithVariables->Formula;
    while (TargetFormula->Type == binary && TargetFormula->FormulaUnion.
BinaryFormula.Connective == disjunction) {
        TargetFormula = TargetFormula->FormulaUnion.BinaryFormula.LHS;
    }

    if (TargetFormula->Type == atom) {
        TargetPredicate = GetSymbol(TargetFormula->FormulaUnion.Atom);
        while (Head != NULL) {
            if (IsPredicateDefinition(Head->AnnotatedFormula,PredicateDefined) 
&& !strcmp(TargetPredicate,PredicateDefined)) {
                return(1);
            }
            Head = Head->Next;
        }
    }

    return(0);
//PossibleDefn->FormulaUnion.BinaryFormula.RHS->Type == unary &&
//PossibleDefn->FormulaUnion.BinaryFormula.RHS->FormulaUnion.UnaryFormula.
//Connective == negation);
//(UnquantifiedDefn = GetUniversalCoreFormula(PossibleDefn->FormulaUnion.
//BinaryFormula.RHS->FormulaUnion.UnaryFormula.Formula)) != NULL &&
//SameFormula(UnquantifiedDefn,SplitFormula,1));
}
//-----------------------------------------------------------------------------
int AllPsuedoSplitDefnsPresent(OptionsType OptionValues,LISTNODE Head,
SIGNATURE Signature) {

    int OKSoFar;
    LISTNODE Target;
    String FormulaName;
    int NumberOfParents;
    StringParts ParentNames;
    LISTNODE ParentAnnotatedFormulae;
    String SZSStatus;
    String InferenceRule;
    String AllParentNames;
    String InferenceInfo;

    OKSoFar = 1;
    Target = Head;
    while (OKSoFar && Target != NULL) {
//----Crap check if it's E's psuedo-splits
        if (DerivedAnnotatedFormula(Target->AnnotatedFormula)) {
            GetInferenceRule(Target->AnnotatedFormula,InferenceRule);
            if (GetInferenceInfoTerm(Target->AnnotatedFormula,InferenceRule,
InferenceInfo) != NULL && ExtractTermArguments(InferenceInfo) &&
strstr(InferenceInfo,"esplit,") == InferenceInfo) {
//----If introduced not expected, just mark as verified
                if (!OptionValues.ExpectIntroducedAxioms) {
                    AddVerifiedTag(Target->AnnotatedFormula,Signature,
"missing_esplit_defn");
                    QPRINTF(OptionValues,2)(
"WARNING: ESplit formula %s not verified because defn's not expected\n",
FormulaName);
//----Otherwise go do serious checking
                } else {
                    GetInferenceStatus(Target->AnnotatedFormula,SZSStatus);
                    GetName(Target->AnnotatedFormula,FormulaName);
//----Get the parents' in various ways. 
                    GetNodeParentNames(Target->AnnotatedFormula,AllParentNames);
                    NumberOfParents = Tokenize(AllParentNames,ParentNames,"\n");
//----ESplits should have split clause and two defn parents
                    if (NumberOfParents != 3 || strcmp(SZSStatus,"thm")) {
                        OKSoFar = 0;
                        QPRINTF(OptionValues,2)(
"FAILURE: ESplit formula %s has wrong inference structure\n",FormulaName);
                    } else {
                        MakeListOfParents(OptionValues,Head,FormulaName,
ParentNames,NumberOfParents,&ParentAnnotatedFormulae);
//----Should be two definitions for esplits
                        if (!FindESplitDefn(Target,ParentAnnotatedFormulae)) {
                            OKSoFar = 0;
                            QPRINTF(OptionValues,2)(
"FAILURE: ESplit formula %s has no definition parent\n",FormulaName);
                        } 
                        FreeListOfAnnotatedFormulae(&ParentAnnotatedFormulae);
                    }
                } 
            }
        }
        Target = Target->Next;
    }

    return(OKSoFar);
}
//-----------------------------------------------------------------------------

//----Check all Skolemization steps have an axiom of choice parent.
    if (!GlobalInterrupted && OKSoFar) {
        if (AllAxiomsOfChoicePresent(OptionValues,Head,Signature)) {
            QPRINTF(OptionValues,2)(
"SUCCESS: All axioms of choice present\n");
        } else {
            OKSoFar = 0;
        }
    }

//----Check all Skolemization steps have an axiom of choice parent.
    if (!GlobalInterrupted && OKSoFar) {
        if (AllPsuedoSplitDefnsPresent(OptionValues,Head,Signature)) {
            QPRINTF(OptionValues,2)(
"SUCCESS: All psuedo-split definitions present\n");
        } else {
            OKSoFar = 0;
        }
    }

