%==============================================================================
%----Configuration for the tptp2X utility. Supplies information about the
%----working directory and Prolog dialect being used.

%----Inspired by Gerd Neugebauer, May 1994.
%----Written by Geoff Sutcliffe, May 1994.
%==============================================================================
%----This specifies your Prolog dialect. Comment in/out the relevant line.
%----The trailing %% comments are important if you want tptp2X_install to
%----keep working (it looks for that). Do not delete them!
% prolog_dialect(generic).                %%generic

%----Works with YAP Prolog, with the following
prolog_dialect(yap).                    %%yap
:-op(0,fx,not).                         %%yap
:-use_module(library(system)).          %%yap

% prolog_dialect(binprolog).              %%binprolog
%----Undefine not which is an operator in BinProlog
% :-op(0,fx,not).                         %%binprolog

% prolog_dialect(swiprolog).              %%swiprolog
% :-op(0,yfx,xor).                        %%swiprolog

% prolog_dialect(sicstus).                %%sicstus
% :-use_module(library(system)).          %%sicstus
% :-use_module(library(random)).          %%sicstus
%----For old SICStus versions put_code(C):-put(C).
%----For old SICStus versions get_code(C):-get0(C).
%----Lines to suppress informational messages
%----If you want silence when using tptp2X/5, then use these lines too.
%----But beware, the last one suppresses SICStus error messages.
% portray_message(informational,_).
% :-prompt(_,'').
% :-open('/dev/null',write,S), prolog_flag(user_error,_,S).

% prolog_dialect(quintus).                %%quintus
%----Library required for tptp2X_delete_file
% :-compile(library(files)).              %%quintus
%----To suppress informational messages when using tptp2X/5
% message_hook(_,_,_).

% prolog_dialect(eclipse).                %%eclipse
%----These lines were supplied by Max Moser from TUM, to get things working.
% :-local(write/1).                       %%eclipse
% write(X):-                              %%eclipse
%     printf("%Dw",[X]).                  %%eclipse
% :-op(0,fy,not).                         %%eclipse
% :-op(0,fy,once).                        %%eclipse
% :-use_module(library(iso)).             %%eclipse
% :-use_module(library(numbervars)).      %%eclipse
% :-dynamic(tptp2X_file_to_include/1).    %%eclipse
% :-dynamic(tptp2X_unique_value/1).       %%eclipse
% :-dynamic(tptp2X_cwd/1).                %%eclipse
%----Optimise the compilation
% :-nodbgcomp.                            %%eclipse
%----Suppress informational output (needed for generators that do a consult
%----while things are running, so the messages are not filtered by the
%----tptp2X script).
% :-set_stream(toplevel_output,null).     %%eclipse
%----These remove error messages and the prompt too, but that's already
%----taken care of by the tptp2X script. Hence they are not installed.
% :-set_error_handler(139,true/0).
% :-set_prompt(toplevel_input,'',null).
%------------------------------------------------------------------------------
%----This specifies the parent directory of the TPTP Problems, Axioms and
%----TPTP2X directories. Do not use a ~ in this.
tptp_directory(X) :- getenv('TPTP', X), !.
%------------------------------------------------------------------------------
