
(* module type RES_CLAUSE = sig *)

    open Hol_type 
    open Term 
    open Symtab
      
exception CLAUSE of string * term
type clause and arityClause and classrelClause
type fol_type
type typ_var
type cclass = string 
type sort  = cclass list
type type_literal
type thmrec = {prop: Term.term}                 (*conclusion*)
type thm = Thm of thmrec
val add_typs_aux : (typ_var * string list) list -> type_literal list * type_literal list
    val prop_of : thm -> term 
(*   val arity_clause_thy: theory -> arityClause list  *)
(*   val ascii_of : string -> string *)
  val bracket_pack : string list -> string
(*   val classrel_clauses_thy: theory -> classrelClause list  *)
  val clause_prefix : string
(*   val clause2tptp : clause -> string * string list *)
  val const_prefix : string
(*   val dfg_write_file:  thm list -> string ->  *)
(*        ((thm * (string * int)) list * classrelClause list * arityClause list) -> string list *)
(*  val fixed_var_prefix : string *)
  val gen_tptp_cls : int * string * string * string -> string
  val gen_tptp_type_cls : int * string * string * string * int -> string
(*   val get_axiomName : clause ->  string *)
(*   val init : theory -> unit *)
   val unzip : ('a * 'b) list -> 'a list * 'b list 
  val isMeta : string -> bool
(*   val isTaut : clause -> bool *)
(*   val keep_types : bool ref *)
(*   val list_ord : ('a * 'b -> order) -> 'a list * 'b list -> order *)
(*   val make_axiom_clause : thm -> string * int -> clause option *)
(*   val make_conjecture_clauses : thm list -> clause list *)
  val make_fixed_const : string -> string
  val make_fixed_type_const : string -> string
  val make_fixed_type_var : string -> string
  val make_fixed_var : string -> string
  val make_schematic_type_var : string * int -> string
  val make_schematic_var : string * int -> string
(*   val make_type_class : string -> string *)
  val mk_fol_type: string * string * fol_type list -> fol_type
  val mk_typ_var_sort : Hol_type.typ -> typ_var * sort
  val paren_pack : string list -> string
(*   val schematic_var_prefix : string *)
(*   val special_equal : bool ref *)
  val string_of_fol_type : fol_type -> string
(*   val tconst_prefix : string  *)
(*   val tfree_prefix : string *)
(*   val tptp_arity_clause : arityClause -> string *)
(*   val tptp_classrelClause : classrelClause -> string *)
  val tptp_of_typeLit : type_literal -> string
  val tptp_tfree_clause : string -> string
  val tptp_write_file: thm list -> string ->  ((thm * (string * int)) list * classrelClause list * arityClause list) -> string list
(*   val tvar_prefix: string *)
  val union_all : 'a list list -> 'a list
      val union_string : 'a list -> 'a list -> 'a list 
  val writeln_strs: out_channel -> string list -> unit
(*   val dfg_sign: bool -> string -> string *)
(*   val dfg_of_typeLit: type_literal -> string *)
(*   val get_tvar_strs: (typ_var * sort) list -> string list *)
(*   val gen_dfg_cls: int * string * string * string * string list -> string *)
(*   val add_foltype_funcs: fol_type * int Symtab.table -> int Symtab.table *)
(*   val add_arityClause_funcs: arityClause * int Symtab.table -> int Symtab.table *)
(*   val add_arityClause_preds: arityClause * int Symtab.table -> int Symtab.table *)
(*   val add_classrelClause_preds : classrelClause * int Symtab.table -> int Symtab.table *)
(*   val dfg_tfree_clause : string -> string *)
(*   val string_of_start: string -> string *)
(*   val string_of_descrip : string -> string *)
(*   val string_of_symbols: string -> string -> string *)
(*   val string_of_funcs: (string * int) list -> string *)
(*   val string_of_preds: (string * int) list -> string *)
(*   val dfg_classrelClause: classrelClause -> string *)
(*   val dfg_arity_clause: arityClause -> string *)

(*  end;; *)
