 

type order = LESS | EQUAL | GREATER
 

type key
type 'a table =
  Empty |
  Branch2 of 'a table * (key * 'a) * 'a table |
  Branch3 of 'a table * (key * 'a) * 'a table * (key * 'a) * 'a table

exception DUP of key
exception DUPS of key list
exception SAME
exception UNDEF of key
val empty: 'a table
val is_empty: 'a table -> bool
val curry : ('a * 'b -> 'c) -> 'a -> 'b -> 'c
val uncurry : ('a -> 'b -> 'c) -> 'a * 'b -> 'c
val ( |> ) : 'a -> ('a -> 'b) -> 'b
val ( |-> ) : 'a * 'b -> ('a -> 'b -> 'c) -> 'c
val ( |>> ) : 'a * 'b -> ('a -> 'c) -> 'c * 'b
val ( ||> ) : 'a * 'b -> ('b -> 'c) -> 'a * 'c
val ( |>>> ) : 'a * 'b -> ('a -> 'c * 'd) -> 'c * ('b * 'd)
val ( ||>> ) : 'a * 'b -> ('b -> 'c * 'd) -> ('a * 'c) * 'd
  (*   val map: ('a -> 'b) -> 'a table -> 'b table *)
(*   val map': (key -> 'a -> 'b) -> 'a table -> 'b table *)
val fold: (key * 'b -> 'a -> 'a) -> 'b table -> 'a -> 'a
  (*   val fold_map: (key * 'b -> 'a -> 'c * 'a) -> 'b table -> 'a -> 'c table * 'a *)
  (*   val foldl: ('a * (key * 'b) -> 'a) -> 'a * 'b table -> 'a *)
val dest: 'a table -> (key * 'a) list
  (*   val keys: 'a table -> key list *)
val min_key: 'a table -> key option
val max_key: 'a table -> key option
  (*   val exists: (key * 'a -> bool) -> 'a table -> bool *)
  (*   val forall: (key * 'a -> bool) -> 'a table -> bool *)
  (*   val defined: 'a table -> key -> bool *)
  (*   val lookup: 'a table -> key -> 'a option *)
val update: (key * 'a) -> 'a table -> 'a table
val update_new: (key * 'a) -> 'a table -> 'a table
val default: key * 'a -> 'a table -> 'a table
val map_entry: key -> ('a -> 'a) -> 'a table -> 'a table
(*   val map_default: (key * 'a) -> ('a -> 'a) -> 'a table -> 'a table *)
(* val make : (key * 'a) list -> 'a table *)
(* val extend: 'a table * (key * 'a) list -> 'a table                   (\*exception DUPS*\) *)
(*   val join: (key -> 'a * 'a -> 'a) (\*exception DUP/SAME*\) -> *)
(*     'a table * 'a table -> 'a table                                    (\*exception DUPS*\) *)
(*   val merge: ('a * 'a -> bool) -> 'a table * 'a table -> 'a table      (\*exception DUPS*\) *)
(*   val delete: key -> 'a table -> 'a table                              (\*exception UNDEF*\) *)
(*   val delete_safe: key -> 'a table -> 'a table *)
(*   val member: ('b * 'a -> bool) -> 'a table -> key * 'b -> bool *)
(*   val insert: ('a * 'a -> bool) -> key * 'a -> 'a table -> 'a table    (\*exception DUP*\) *)
(*   val remove: ('b * 'a -> bool) -> key * 'b -> 'a table -> 'a table *)
(*   val lookup_list: 'a list table -> key -> 'a list *)
(*   val update_list: (key * 'a) -> 'a list table -> 'a list table *)
(*   val insert_list: ('a * 'a -> bool) -> key * 'a -> 'a list table -> 'a list table *)
(*   val remove_list: ('b * 'a -> bool) -> key * 'b -> 'a list table -> 'a list table *)
(*   val make_list: (key * 'a) list -> 'a list table *)
(*   val dest_list: 'a list table -> (key * 'a) list *)
(*   val merge_list: ('a * 'a -> bool) -> *)
(*     'a list table * 'a list table -> 'a list table *)


