
;;;
;;; This domain added for testing the abstraction stuff.

(create-problem-space 'mathserv1 :current t)

(ptype-of OWL-TSTPPROBLEM :top-type)
(ptype-of OWL-TSTPFOFPROBLEM OWL-TSTPPROBLEM)
(ptype-of OWL-TSTPCNFPROBLEM OWL-TSTPPROBLEM)
(ptype-of OWL-FOATPRESULT :top-type)
(ptype-of OWL-NDPROOF :top-type)

(ptype-of OWL-PROBLEMCLASS :top-type)
(pinstance-of pure-equality-class OWL-PROBLEMCLASS)
;; (pinstance-of essentially-propositinal-class OWL-PROBLEMCLASS)

(OPERATOR
 TrampCNF
 (params <fofproblem> <cnfproblem>)
 (preconds
  (
   (<fofproblem> OWL-TSTPFOFPROBLEM)
   (<cnfproblem> OWL-TSTPCNFPROBLEM)
   )
  (and
   (bound <fofproblem>)
   (unbound <cnfproblem>)
   ))
 (effects
  (
   (<class> OWL-PROBLEMCLASS)
   )
  (
   (del (unbound <cnfproblem>))
   (add (bound <cnfproblem>))
   (add (satEquiv <cnfproblem> <fofproblem>))
   (add (deltaRelated <cnfproblem> <fofproblem>))
   (if (problem-class <fofproblem> <class>)
       ((add (problem-class <cnfproblem> <class>)))
     )
   ))
 )


(OPERATOR
 OtterATP
 (params <tstpproblem> <result>)
 (preconds
  ((<tstpproblem> OWL-TSTPPROBLEM)
   (<result> OWL-FOATPRESULT)
   )
  (and
   (bound <tstpproblem>)
   (unbound <result>)
   ))
 (effects
  ()
  (
   (del (unbound <result>))
   (add (bound <result>))
   (add (atpResultFor <result> <tstpproblem>))
   ))
 )

(OPERATOR
 EpATP
 (params <tstpproblem> <result>)
 (preconds
  (
   (<tstpproblem> OWL-TSTPPROBLEM)
   (<result> OWL-FOATPRESULT)
   )
  (and
   (bound <tstpproblem>)
   (unbound <result>)
   )
  )
 (effects
  ()
  (
   (del (unbound <result>))
   (add (bound <result>))
   (add (atpResultFor <result> <tstpproblem>))
   )))

(OPERATOR
 TrampNDforFOF
 (params <fofproblem> <atpresult> <ndProof>)
 (preconds
  (
   (<fofproblem> OWL-TSTPFOFPROBLEM)
   (<atpresult> OWL-FOATPRESULT)
   (<ndProof> OWL-NDPROOF)
   )
  (and
   (bound <fofproblem>)
   (bound <atpresult>)
   (unbound <ndProof>)
   (exists ((<cnfproblem> OWL-TSTPCNFPROBLEM))
	   (and
	    (bound <cnfproblem>)
	    (atpResultFor <atpresult> <cnfproblem>)
	    (deltaRelated <cnfproblem> <fofproblem>)
	    )))
  )
 
 (effects
  ()
  (
   (del (unbound <ndProof>))
   (add (bound <ndProof>))
   (add (proofOf <ndProof> <fofproblem>))
   )))

(Control-Rule prefer-ep-for-pure-equality-problems
	      (if (and
		   (current-goal (atpResultFor <x> <y>))
		   (true-in-state (problem-class <y> pure-equality-class))
		   ))
	      (then prefer operator EpATP <anything>))

;; (Inference-rule propagate-problem-classification-inference
;; 		(mode lazy)
;; 		;;		(mode eager)
;; 		(params <cnfproblem> <fofproblem> <class>)
;; 		(preconds
;; 		 ((<cnfproblem> OWL-TSTPCNFPROBLEM)
;; 		  (<fofproblem> OWL-TSTPFOFPROBLEM)
;; 		  (<class> OWL-PROBLEMCLASS)
;; 		  )
;; 		 (and
;; 		  (satEquiv <cnfproblem> <fofproblem>)
;; 		  (problem-class <fofproblem> <class>)
;; 		  ))
;; 		(effects
;; 		 ()
;; 		 (
;; 		  (add (problem-class <cnfproblem> <class>))
;; 		  )))
		 

;; (Control-Rule select-goal
;; 	      (if (and
;; 		   (candidate-goal (atpResultFor <atpresult> <cnfproblem>))
;; 		   (candidate-goal (deltaRelated <cnfproblem> <fofproblem>))
;; 		   ))
;; 	      (then prefer goal (deltaRelated <cnfproblem> <fofproblem>) <anything>)
;; 	      )


;; (Control-Rule reject-second-prover
;; 	      (if (and
;; 		   (candidate-operator <op>)
;; 		   (expanded-operator (<op> <x> <w>)))
;; 		  )
;; 	      (then reject operator <op>)
;; 	      )

(setf (current-problem)
      (create-problem
       (name trampnd)
       (objects
	(fofproblem OWL-TSTPFOFPROBLEM)
	(ndProof OWL-NDPROOF)
	(x11 OWL-TSTPCNFPROBLEM)
	(x12 OWL-FOATPRESULT)
;;	(x13 OWL-FOATPRESULT)
	(y11 OWL-TSTPCNFPROBLEM)
;;	(y12 OWL-FOATPRESULT)
;;	(y13 OWL-FOATPRESULT)
	
;;	(pure-equality-class OWL-PROBLEMCLASS)
;;	(essentially-propositinal-class OWL-PROBLEMCLASS)
	;; 	(x12 OWL-TSTPCNFPROBLEM)
;; 	(x2 OWL-FOATPRESULT)
;; 	(x3 OWL-FOATPRESULT)
	)
       (state
	(and
	 (bound fofproblem)
	 (unbound x11)
	 (unbound x12)
;;	 (unbound x13)	 
	 (unbound y11)
;;	 (unbound y12)
;;	 (unbound y13)
	 (unbound ndProof)
	 (problem-class fofproblem pure-equality-class) 
	 )
	)
       (goal
	(and
	 (bound ndProof)
	 (proofOf ndProof fofproblem)

	 ))))








