
;;;
;;; This domain added for testing the abstraction stuff.

(create-problem-space 'mathserv1 :current t)

(ptype-of OWL-Logic :top-type)
(ptype-of OWL-Resource :top-type)
(ptype-of OWL-Output :top-type)
(ptype-of OWL-Calculus :top-type)
(ptype-of OWL-Problem :top-type)
(ptype-of OWL-FormalLanguage :top-type)
(ptype-of OWL-Proof :top-type)
(ptype-of OWL-ProverState :top-type)
(ptype-of OWL-FOProblemFormat :top-type)
(ptype-of OWL-Result :top-type)
(ptype-of OWL-SetTheory OWL-Logic)
(ptype-of OWL-HOLogic OWL-Logic)
(ptype-of OWL-FOLogic OWL-Logic)
(ptype-of OWL-TimeResource OWL-Resource)
(ptype-of OWL-FORefutation OWL-Output)
(ptype-of OWL-Assurance OWL-Output)
(ptype-of OWL-NDCalculus OWL-Calculus)
(ptype-of OWL-ResolutionCalculus OWL-Calculus)
(ptype-of OWL-SequentCalculus OWL-Calculus)
(ptype-of OWL-DecisionProblem OWL-Problem)
(ptype-of OWL-SolvingProblem OWL-Problem)
(ptype-of OWL-ComputationProblem OWL-Problem)
(ptype-of OWL-ProvingProblem OWL-Problem)
(ptype-of OWL-InformalProof OWL-Proof)
(ptype-of OWL-FormalProof OWL-Proof)
(ptype-of OWL-FOATPState OWL-ProverState)
(ptype-of OWL-ProverResult OWL-Result)
(ptype-of OWL-ModelGeneratorResult OWL-Result)
(ptype-of OWL-Failure OWL-Result)
(ptype-of OWL-DecisionProcResult OWL-Result)
(ptype-of OWL-ConstructiveNDCalculus OWL-NDCalculus)
(ptype-of OWL-ClassicalNDCalculus OWL-NDCalculus)
(ptype-of OWL-BfFPResolutionCalculus OWL-ResolutionCalculus)
(ptype-of OWL-OmdocProvingProblem OWL-ProvingProblem)
(ptype-of OWL-FOProvingProblem OWL-ProvingProblem)
(ptype-of OWL-ResolutionProof OWL-FormalProof)
(ptype-of OWL-NDProof OWL-FormalProof)
(ptype-of OWL-FOATPResult OWL-ProverResult)
(ptype-of OWL-FOOmdocProvingProblem OWL-OmdocProvingProblem)
(ptype-of OWL-TstpProblem OWL-FOProvingProblem)
(ptype-of OWL-TstpCNFRefutation OWL-ResolutionProof)
(ptype-of OWL-TwegaNDProof OWL-NDProof)
(ptype-of OWL-FOBrFPResult OWL-FOATPResult)
(ptype-of OWL-TstpCNFProblem OWL-TstpProblem)
(ptype-of OWL-TstpFOFProblem OWL-TstpProblem)
(ptype-of OWL-TstpCnfLcRefutation OWL-TstpCNFRefutation)
(ptype-of OWL-TstpCnfBrFPRefutation OWL-TstpCnfLcRefutation)
(ptype-of OWL-ProblemClass :top-type)


(pinstance-of sat_epr_fof OWL-ProblemClass)
;;(pinstance-of brfp OWL-FOBrFPResult)
;; (pinstance-of essentially-propositinal-class OWL-PROBLEMCLASS)

(OPERATOR
 TrampCNF
 (params <fofproblem> <cnfproblem>)
 (preconds
  (
   (<fofproblem> OWL-TstpFOFProblem)
   (<cnfproblem> OWL-TstpCNFProblem)
   )
  (and
   (bound <fofproblem>)
   (unbound <cnfproblem>)
   ))
 (effects
  (
   (<class> OWL-ProblemClass)
   )
  (
   (del (unbound <cnfproblem>))
   (add (bound <cnfproblem>))
   (add (satEquivalentTo <cnfproblem> <fofproblem>))
   (add (deltaRelatedTo <cnfproblem> <fofproblem>))
   (if (and (problemClass <fofproblem> <class>))
       ((add (problemClass <cnfproblem> <class>)))
     )
   ))
 )


(OPERATOR
 OtterATP
 (params <tstpproblem> <result>)
 (preconds
  (
   (<tstpproblem> OWL-TstpProblem)
   (<result> OWL-FOBrFPResult)
   )
  (and
   (bound <tstpproblem>)
   (unbound <result>)
   ))
 (effects
  ()
  (
   (del (unbound <result>))
   (add (bound <result>))
   (add (resultFor <result> <tstpproblem>))
   ))
 ) 

(OPERATOR
 EpATP
 (params <tstpproblem> <result>)
 (preconds
  (
   (<tstpproblem> OWL-TstpProblem)
   (<result> OWL-FOATPResult)
   )
  (and
   (bound <tstpproblem>)
   (unbound <result>)
   )
  )
 (effects
  ()
  (
   (del (unbound <result>))
   (add (bound <result>))
   (add (resultFor <result> <tstpproblem>))
   )))

(Control-Rule prefer-ep-1
	      (if (and
		   (current-goal (resultFor <x> <y>))
		   (true-in-state (problem-class <y> sat_epr_fof))
		   ))
	      (then prefer operator EpATP <anything>))


(Control-Rule reject-wrong-binding-epatp
	      (if (and
		   (applicable-operator (EpATP <x1> <result>))
		   (~ (exact-type-of-object <result> OWL-FOATPResult))
		   ))
	      (then sub-goal))

(OPERATOR
 Otterfier
 (params <oldresult> <newresult>)
 (preconds
  (
   (<oldresult> OWL-FOATPResult)
   (<newresult> OWL-FOBrFPResult)
   (<problem> OWL-TstpProblem)
   )
  (and
   (bound <oldresult>)
   (unbound <newresult>)
   (resultFor <oldresult> <problem>)
   )
  )
 (effects
  (
   )
  (
   (del (unbound <newresult>))
   (add (bound <newresult>))
   (add (resultFor <newresult> <problem>))
   )))

(OPERATOR
 TrampNDforFOF
 (params <fofproblem> <atpresult> <ndProof>)
 (preconds
  (
   (<fofproblem> OWL-TstpFOFProblem)
   (<atpresult> OWL-FOBrFPResult)
   (<ndProof> OWL-NDProof)
   (<cnfproblem> OWL-TstpCNFProblem)
   )
  (and
   (bound <fofproblem>)
   (bound <atpresult>)
   (bound <cnfproblem>)
   (unbound <ndProof>)

   (resultFor <atpresult> <cnfproblem>)
   (deltaRelatedTo <cnfproblem> <fofproblem>)
   )
  )
 
 (effects
  ()
  (
   (del (unbound <ndProof>))
   (add (bound <ndProof>))
   (add (proofOf <ndProof> <fofproblem>))
   )))

;;    (exists ((<cnfproblem> OWL-TstpCNFProblem))
;; 	   (and
;; 	    (bound <cnfproblem>)
;; 	    (resultFor <atpresult> <cnfproblem>)
;; 	    (deltaRelatedTo <cnfproblem> <fofproblem>)
;; 	    )))



;; (Inference-rule propagate-problem-classification-inference
;; 		(mode lazy)
;; 		;;		(mode eager)
;; 		(params <cnfproblem> <fofproblem> <class>)
;; 		(preconds
;; 		 ((<cnfproblem> OWL-TstpCNFProblem)
;; 		  (<fofproblem> OWL-TstpFOFProblem)
;; 		  (<class> OWL-ProblemClass)
;; 		  )
;; 		 (and
;; 		  (satEquivalentTo <cnfproblem> <fofproblem>)
;; 		  (problem-class <fofproblem> <class>)
;; 		  ))
;; 		(effects
;; 		 ()
;; 		 (
;; 		  (add (problem-class <cnfproblem> <class>))
;; 		  )))
		 

;; (Control-Rule select-goal
;; 	      (if (and
;; 		   (candidate-goal (resultFor <atpresult> <cnfproblem>))
;; 		   (candidate-goal (deltaRelatedTo <cnfproblem> <fofproblem>))
;; 		   ))
;; 	      (then prefer goal (deltaRelatedTo <cnfproblem> <fofproblem>) <anything>)
;; 	      )


;; (Control-Rule reject-second-prover
;; 	      (if (and
;; 		   (candidate-operator <op>)
;; 		   (expanded-operator (<op> <x> <w>)))
;; 		  )
;; 	      (then reject operator <op>)
;; 	      )

(setf (current-problem)
      (create-problem
       (name trampnd)
       (objects
	(fofproblem OWL-TstpFOFProblem)
	(ndProof OWL-NDProof)
	(x11 OWL-TstpCNFProblem)
	(x3 OWL-FOATPResult)
	(brfp OWL-FOBrFPResult)	
	)
       (state
	(and
	 (bound fofproblem)

	 (unbound x11)
	 (unbound brfp)
	 (unbound x3)	 

	 (unbound ndProof)
	 (problem-class fofproblem sat_epr_fof) 
	 )
	)
       (goal
	(and
	 (bound ndProof)
	 (proofOf ndProof fofproblem)
	 ))))








