
;;;
;;; This domain added for testing the abstraction stuff.

(create-problem-space 'mathserv1 :current t)

(ptype-of OWL-Thing :top-type)
(ptype-of OWL-ProblemClass OWL-Thing)
(ptype-of OWL-Calculus OWL-Thing)
(ptype-of OWL-FormalLanguage OWL-Thing)
(ptype-of OWL-ProverState OWL-Thing)
(ptype-of OWL-Specialisation OWL-Thing)
(ptype-of OWL-Logic OWL-Thing)
(ptype-of OWL-Resource OWL-Thing)
(ptype-of OWL-Output OWL-Thing)
(ptype-of OWL-ProblemFeature OWL-Thing)
(ptype-of OWL-Problem OWL-Thing)
(ptype-of OWL-Proof OWL-Thing)
(ptype-of OWL-FOProblemFormat OWL-Thing)
(ptype-of OWL-Result OWL-Thing)
(ptype-of OWL-ProvingProblemClass OWL-ProblemClass)
(ptype-of OWL-NDCalculus OWL-Calculus)
(ptype-of OWL-ResolutionCalculus OWL-Calculus)
(ptype-of OWL-SequentCalculus OWL-Calculus)
(ptype-of OWL-FOATPState OWL-ProverState)
(ptype-of OWL-FOSpecialisation OWL-Specialisation)
(ptype-of OWL-SetTheory OWL-Logic)
(ptype-of OWL-HOLogic OWL-Logic)
(ptype-of OWL-FOLogic OWL-Logic)
(ptype-of OWL-TimeResource OWL-Resource)
(ptype-of OWL-FORefutation OWL-Output)
(ptype-of OWL-Assurance OWL-Output)
(ptype-of OWL-ProvingProblemFeature OWL-ProblemFeature)
(ptype-of OWL-DecisionProblem OWL-Problem)
(ptype-of OWL-SolvingProblem OWL-Problem)
(ptype-of OWL-ComputationProblem OWL-Problem)
(ptype-of OWL-ProvingProblem OWL-Problem)
(ptype-of OWL-InformalProof OWL-Proof)
(ptype-of OWL-FormalProof OWL-Proof)
(ptype-of OWL-ModelGeneratorResult OWL-Result)
(ptype-of OWL-ProverResult OWL-Result)
(ptype-of OWL-Failure OWL-Result)
(ptype-of OWL-DecisionProcResult OWL-Result)
(ptype-of OWL-FOProblemClass OWL-ProvingProblemClass)
(ptype-of OWL-ConstructiveNDCalculus OWL-NDCalculus)
(ptype-of OWL-ClassicalNDCalculus OWL-NDCalculus)
(ptype-of OWL-BfFPResolutionCalculus OWL-ResolutionCalculus)
(ptype-of OWL-FOProblemFeature OWL-ProvingProblemFeature)
(ptype-of OWL-OmdocProvingProblem OWL-ProvingProblem)
(ptype-of OWL-FOProvingProblem OWL-ProvingProblem)
(ptype-of OWL-ResolutionProof OWL-FormalProof)
(ptype-of OWL-NDProof OWL-FormalProof)
(ptype-of OWL-FOATPResult OWL-ProverResult)
(ptype-of OWL-FOOmdocProvingProblem OWL-OmdocProvingProblem)
(ptype-of OWL-TstpProblem OWL-FOProvingProblem)
(ptype-of OWL-TstpCNFRefutation OWL-ResolutionProof)
(ptype-of OWL-TwegaNDProof OWL-NDProof)
(ptype-of OWL-FOBrFPResult OWL-FOATPResult)
(ptype-of OWL-TstpCNFProblem OWL-TstpProblem)
(ptype-of OWL-TstpFOFProblem OWL-TstpProblem)
(ptype-of OWL-TstpCnfLcRefutation OWL-TstpCNFRefutation)
(ptype-of OWL-TstpCnfBrFPRefutation OWL-TstpCnfLcRefutation)


;;(pinstance-of brfp OWL-FOBRFPRESULT)
;; (pinstance-of essentially-propositinal-class OWL-PROBLEMCLASS)

(ptype-of  OWL-HO2FOTranslation  OWL-Thing)
(ptype-of  OWL-HOProblem OWL-Thing)
(ptype-of  OWL-HOATPResult OWL-Thing)

(pinstance-of pure-equality-class OWL-PROBLEMCLASS)
(pinstance-of fores3 OWL-FOATPRESULT)
;;	(pinstance-of fores4 OWL-FOATPRESULT)
(pinstance-of hotrans1  OWL-HO2FOTranslation)
;;	(pinstance-of hopr2  OWL-HOProblem)
(pinstance-of hores2  OWL-HOATPResult)
(pinstance-of brfpres OWL-FOBRFPRESULT)	

(OPERATOR
 HOP2FOP
 (params <hoproblem> <fofproblem> <translation>)
 (preconds
  (
   (<fofproblem> OWL-TSTPFOFPROBLEM)
   (<hoproblem> OWL-HOProblem )
   (<translation> OWL-HO2FOTranslation)
   )
  (and
   (bound <hoproblem>)
   (~ (bound <fofproblem>))
   (~ (bound <translation>))
   ))
 (effects
  (
   )
  (
   (add (bound <fofproblem>))
   (add (bound <translation>))
   (add (translationOf <fofproblem> <hoproblem>))
   (add (translationFor <hoproblem> <translation>))
   ))
 )

(pinstance-of fofproblem1 OWL-TSTPFOFPROBLEM)
(pinstance-of x11 OWL-TSTPCNFPROBLEM)

(OPERATOR
 TPS
 (params <hoproblem> <result>)
 (preconds
  (
   (<hoproblem> OWL-HOProblem)
   (<result> OWL-HOATPResult)
   )
  (and
   (bound <hoproblem>)
   (~ (bound <result>))
   ))
 (effects
  ()
  (
   (add (bound <result>))
   (add (resultFor <result> <hoproblem>))
   ))
 )

(OPERATOR
 FOResult2HOResult
 (params <foresult> <translation> <horesult>)
 (preconds
  (
   (<foresult> OWL-FOATPResult)
   (<horesult> OWL-HOATPResult)
   (<translation> OWL-HO2FOTranslation)

   (<hoproblem> OWL-HOProblem)
   (<foproblem> OWL-TSTPPROBLEM)
   )
  (and
   (bound <foresult>)
   (bound <translation>)
   (~ (bound <horesult>))
   (resultFor <foresult> <foproblem>)
   (translationOf <foproblem> <hoproblem>)
   (translationFor <hoproblem> <translation>)
   ))
 (effects
  ()
  (
   (add (bound <horesult>))
   (add (resultFor <horesult> <hoproblem>))
   ))
 )

(Control-Rule reject-wrong-binding-FOResult2HOResult
	      (if (and
		   (applicable-operator (FOResult2HOResult <x> <y> <result>))
		   (~ (exact-type-of-object <result> OWL-FOATPRESULT))
		   ))
              (then sub-goal))


(OPERATOR
 TrampCNF
 (params <fofproblem> <cnfproblem>)
 (preconds
  (
   (<fofproblem> OWL-TSTPFOFPROBLEM)
   (<cnfproblem> OWL-TSTPCNFPROBLEM )
   )
  (and
   (bound <fofproblem>)
   (~ (bound <cnfproblem>))
   ))
 (effects
  (
   (<class> OWL-PROBLEMCLASS)
   )
  (
   (add (bound <cnfproblem>))
   (add (satEquiv <cnfproblem> <fofproblem>))
   (add (deltaRelated <cnfproblem> <fofproblem>))
   (if (and (problem-class <fofproblem> <class>))
       ((add (problem-class <cnfproblem> <class>)))
     )
   ))
 )


(OPERATOR
 OtterATP
 (params <tstpproblem> <result>)
 (preconds
  (
   (<tstpproblem> OWL-TSTPPROBLEM)
   (<result> OWL-FOBrFPResult)
   )
  (and
   (bound <tstpproblem>)
   (~ (bound <result>))
   ))
 (effects
  ()
  (
   (add (bound <result>))
   (add (resultFor <result> <tstpproblem>))
   ))
 )

(Control-Rule reject-wrong-binding-otter
	      (if (and
		   (applicable-operator (OtterATP <x> <result>))
		   (or (~ (exact-type-of-object <result> OWL-FOBrFPResult)))
		   ))
              (then sub-goal))


(OPERATOR
 EpATP
 (params <tstpproblem> <result>)
 (preconds
  (
   (<tstpproblem> OWL-TSTPPROBLEM)
   (<result> OWL-FOATPRESULT)
   )
  (and
   (bound <tstpproblem>)
   (~ (bound <result>))
   )
  )
 (effects
  ()
  (
   (add (bound <result>))
   (add (resultFor <result> <tstpproblem>))
   )))

(Control-Rule reject-wrong-binding-epatp
	      (if (and
		   (applicable-operator (EpATP <x1> <result>))
		   (~ (exact-type-of-object <result> OWL-FOATPRESULT))
		   ))
              (then sub-goal))

(OPERATOR
 Otterfier
 (params <oldresult> <newresult>)
 (preconds
  (
   (<oldresult> OWL-FOATPRESULT)
   (<newresult> OWL-FOBRFPRESULT)
   (<problem> OWL-TSTPPROBLEM)
   )
  (and
   (bound <oldresult>)
   (~ (bound <newresult>))
   (resultFor <oldresult> <problem>)
   )
  )
 (effects
  (
   )
  (
   (add (bound <newresult>))
   (add (resultFor <newresult> <problem>))
   )))

(OPERATOR
 TrampNDforFOF
 (params <fofproblem> <atpresult> <ndProof>)
 (preconds
  (
   (<fofproblem> OWL-TSTPFOFPROBLEM)
   (<atpresult> OWL-FOBRFPRESULT)
   (<ndProof> OWL-NDPROOF)
   (<cnfproblem> OWL-TSTPCNFPROBLEM)
   )
  (and
   (bound <fofproblem>)
   (bound <atpresult>)
   (bound <cnfproblem>)
   (~ (bound <ndProof>))

   (resultFor <atpresult> <cnfproblem>)
   (deltaRelated <cnfproblem> <fofproblem>)
   )
  )
 
 (effects
  ()
  (
   (add (bound <ndProof>))
   (add (proofOf <ndProof> <fofproblem>))
   )))

(pinstance-of ndProof OWL-NDPROOF)

;;    (exists ((<cnfproblem> OWL-TSTPCNFPROBLEM))
;; 	   (and
;; 	    (bound <cnfproblem>)
;; 	    (resultFor <atpresult> <cnfproblem>)
;; 	    (deltaRelated <cnfproblem> <fofproblem>)
;; 	    )))



;; (Inference-rule propagate-problem-classification-inference
;; 		(mode lazy)
;; 		;;		(mode eager)
;; 		(params <cnfproblem> <fofproblem> <class>)
;; 		(preconds
;; 		 ((<cnfproblem> OWL-TSTPCNFPROBLEM)
;; 		  (<fofproblem> OWL-TSTPFOFPROBLEM)
;; 		  (<class> OWL-PROBLEMCLASS)
;; 		  )
;; 		 (and
;; 		  (satEquiv <cnfproblem> <fofproblem>)
;; 		  (problem-class <fofproblem> <class>)
;; 		  ))
;; 		(effects
;; 		 ()
;; 		 (
;; 		  (add (problem-class <cnfproblem> <class>))
;; 		  )))
		 


;; (Control-Rule prefer-ep-1
;; 	      (if (and
;; 		   (current-goal (resultFor <x> <y>))
;; 		   ;;		   (type-of-object <x> OWL-FOATPRESULT)
;; 		   (true-in-state (problem-class <y> pure-equality-class))
;; 		   ))
;; 	      (then prefer operator EpATP <anything>))


;; (Control-Rule select-goal
;; 	      (if (and
;; 		   (candidate-goal (resultFor <atpresult> <cnfproblem>))
;; 		   (candidate-goal (deltaRelated <cnfproblem> <fofproblem>))
;; 		   ))
;; 	      (then prefer goal (deltaRelated <cnfproblem> <fofproblem>) <anything>)
;; 	      )


;; (Control-Rule reject-second-prover
;; 	      (if (and
;; 		   (candidate-operator <op>)
;; 		   (expanded-operator (<op> <x> <w>)))
;; 		  )
;; 	      (then reject operator <op>)
;; 	      )

(setf (current-problem)
      (create-problem
;;       (name foo)
       (objects
 	(hopr1  OWL-HOProblem)
	(hores1  OWL-HOATPResult)
	)
       (state
	(and
	 (bound hopr1)
	 )
	)
       (goal
	(and
	 (bound hores1)
	 (resultFor hores1 hopr1)
	 )
	)))








