
;;;
;;; This domain added for testing the abstraction stuff.

(create-problem-space 'mathserv1 :current t)

(ptype-of OWL-Thing :top-type)
(ptype-of OWL-ProblemClass OWL-Thing)
(ptype-of OWL-Calculus OWL-Thing)
(ptype-of OWL-FormalLanguage OWL-Thing)
(ptype-of OWL-ProverState OWL-Thing)
(ptype-of OWL-Specialisation OWL-Thing)
(ptype-of OWL-Logic OWL-Thing)
(ptype-of OWL-Resource OWL-Thing)
(ptype-of OWL-Output OWL-Thing)
(ptype-of OWL-ProblemFeature OWL-Thing)
(ptype-of OWL-Problem OWL-Thing)
(ptype-of OWL-Proof OWL-Thing)
(ptype-of OWL-FOProblemFormat OWL-Thing)
(ptype-of OWL-Result OWL-Thing)
(ptype-of OWL-ProvingProblemClass OWL-ProblemClass)
(ptype-of OWL-NDCalculus OWL-Calculus)
(ptype-of OWL-ResolutionCalculus OWL-Calculus)
(ptype-of OWL-SequentCalculus OWL-Calculus)
(ptype-of OWL-FOATPState OWL-ProverState)
(ptype-of OWL-FOSpecialisation OWL-Specialisation)
(ptype-of OWL-SetTheory OWL-Logic)
(ptype-of OWL-HOLogic OWL-Logic)
(ptype-of OWL-FOLogic OWL-Logic)
(ptype-of OWL-TimeResource OWL-Resource)
(ptype-of OWL-FORefutation OWL-Output)
(ptype-of OWL-Assurance OWL-Output)
(ptype-of OWL-ProvingProblemFeature OWL-ProblemFeature)
(ptype-of OWL-DecisionProblem OWL-Problem)
(ptype-of OWL-SolvingProblem OWL-Problem)
(ptype-of OWL-ComputationProblem OWL-Problem)
(ptype-of OWL-ProvingProblem OWL-Problem)
(ptype-of OWL-InformalProof OWL-Proof)
(ptype-of OWL-FormalProof OWL-Proof)
(ptype-of OWL-ModelGeneratorResult OWL-Result)
(ptype-of OWL-ProverResult OWL-Result)
(ptype-of OWL-Failure OWL-Result)
(ptype-of OWL-DecisionProcResult OWL-Result)
(ptype-of OWL-FOProblemClass OWL-ProvingProblemClass)
(ptype-of OWL-ConstructiveNDCalculus OWL-NDCalculus)
(ptype-of OWL-ClassicalNDCalculus OWL-NDCalculus)
(ptype-of OWL-BfFPResolutionCalculus OWL-ResolutionCalculus)
(ptype-of OWL-FOProblemFeature OWL-ProvingProblemFeature)
(ptype-of OWL-OmdocProvingProblem OWL-ProvingProblem)
(ptype-of OWL-FOProvingProblem OWL-ProvingProblem)
(ptype-of OWL-ResolutionProof OWL-FormalProof)
(ptype-of OWL-NDProof OWL-FormalProof)
(ptype-of OWL-FOATPResult OWL-ProverResult)
(ptype-of OWL-FOOmdocProvingProblem OWL-OmdocProvingProblem)
(ptype-of OWL-TstpProblem OWL-FOProvingProblem)
(ptype-of OWL-TstpCNFRefutation OWL-ResolutionProof)
(ptype-of OWL-TwegaNDProof OWL-NDProof)
(ptype-of OWL-FOBrFPResult OWL-FOATPResult)
(ptype-of OWL-TstpCNFProblem OWL-TstpProblem)
(ptype-of OWL-TstpFOFProblem OWL-TstpProblem)
(ptype-of OWL-TstpCnfLcRefutation OWL-TstpCNFRefutation)
(ptype-of OWL-TstpCnfBrFPRefutation OWL-TstpCnfLcRefutation)


;;(pinstance-of brfp OWL-FOBRFPRESULT)
;; (pinstance-of essentially-propositinal-class OWL-PROBLEMCLASS)

(OPERATOR www.mathweb.org/owl/atp/OtterService.owl#OtterProveService
(params  <tstp_problem> <atp_result>)
(preconds 
 (
  (<tstp_problem> OWL-TstpProblem)
  (<atp_result> OWL-FOBrFPResult)
 )
 (and
  (bound <tstp_problem>)
  (~ (bound <atp_result>))
 ))
(effects 
 ( )
 (
   (add (bound <atp_result>))
   (add (resultFor <atp_result> <tstp_problem>))
)))

(pinstance-of object_atp_result_1 OWL-FOBrFPResult)


(Control-Rule reject-wrong-binding-for-www.mathweb.org/owl/atp/OtterService.owl#OtterProveService
  (if (and
        (applicable-operator (www.mathweb.org/owl/atp/OtterService.owl#OtterProveService <tstp_problem>  <atp_result>))
        (or
         (~ (exact-type-of-object <atp_result> OWL-FOBrFPResult))
         )))
  (then sub-goal))

(OPERATOR www.mathweb.org/owl/atp/EService.owl#EpProveService
(params  <tstp_problem> <atp_result>)
(preconds 
 (
  (<tstp_problem> OWL-TstpProblem)
  (<atp_result> OWL-FOATPResult)
 )
 (and
  (bound <tstp_problem>)
  (~ (bound <atp_result>))
 ))
(effects 
 ( )
 (
   (add (bound <atp_result>))
   (add (resultFor <atp_result> <tstp_problem>))
)))

(pinstance-of object_atp_result_2 OWL-FOATPResult)


(Control-Rule reject-wrong-binding-for-www.mathweb.org/owl/atp/EService.owl#EpProveService
  (if (and
        (applicable-operator (www.mathweb.org/owl/atp/EService.owl#EpProveService <tstp_problem>  <atp_result>))
        (or
         (~ (exact-type-of-object <atp_result> OWL-FOATPResult))
         )))
  (then sub-goal))

(OPERATOR www.mathweb.org/owl/trans/TrampCNFService.owl#TrampCNFService
(params  <fof_problem> <cnf_problem>)
(preconds 
 (
  (<fof_problem> OWL-TstpFOFProblem)
  (<cnf_problem> OWL-TstpCNFProblem)
 )
 (and
  (bound <fof_problem>)
  (~ (bound <cnf_problem>))
 ))
(effects 
 ( )
 (
   (add (bound <cnf_problem>))
   (add (deltaRelatedTo <cnf_problem> <fof_problem>))
   (add (satEquivalentTo <cnf_problem> <fof_problem>))
)))

(pinstance-of object_cnf_problem_3 OWL-TstpCNFProblem)


(Control-Rule reject-wrong-binding-for-www.mathweb.org/owl/trans/TrampCNFService.owl#TrampCNFService
  (if (and
        (applicable-operator (www.mathweb.org/owl/trans/TrampCNFService.owl#TrampCNFService <fof_problem>  <cnf_problem>))
        (or
         (~ (exact-type-of-object <cnf_problem> OWL-TstpCNFProblem))
         )))
  (then sub-goal))

(OPERATOR www.mathweb.org/owl/trans/TrampNDService.owl#TrampNDService
(params  <fof_problem> <atp_result> <nd_proof>)
(preconds 
 (
  (<fof_problem> OWL-TstpFOFProblem)
  (<atp_result> OWL-FOBrFPResult)
  (<nd_proof> OWL-TwegaNDProof)
  (<cnf_problem> OWL-Thing)
 )
 (and
  (bound <fof_problem>)
  (bound <atp_result>)
  (~ (bound <nd_proof>))
  (deltaRelatedTo <cnf_problem> <fof_problem>)
  (resultFor <atp_result> <cnf_problem>)
 ))
(effects 
 ( )
 (
   (add (bound <nd_proof>))
   (add (proofOf <nd_proof> <fof_problem>))
)))

(pinstance-of object_nd_proof_4 OWL-TwegaNDProof)


(Control-Rule reject-wrong-binding-for-www.mathweb.org/owl/trans/TrampNDService.owl#TrampNDService
  (if (and
        (applicable-operator (www.mathweb.org/owl/trans/TrampNDService.owl#TrampNDService <fof_problem>  <atp_result>  <nd_proof>))
        (or
         (~ (exact-type-of-object <nd_proof> OWL-TwegaNDProof))
         )))
  (then sub-goal))

(OPERATOR www.mathweb.org/owl/trans/OtterfierService.owl#OtterfierService
(params  <atp_result> <new_result>)
(preconds 
 (
  (<atp_result> OWL-FOATPResult)
  (<new_result> OWL-FOBrFPResult)
  (<proving_problem> OWL-Thing)
 )
 (and
  (bound <atp_result>)
  (~ (bound <new_result>))
  (resultFor <atp_result> <proving_problem>)
 ))
(effects 
 ( )
 (
   (add (bound <new_result>))
   (add (resultFor <new_result> <proving_problem>))
)))

(pinstance-of object_new_result_5 OWL-FOBrFPResult)


(Control-Rule reject-wrong-binding-for-www.mathweb.org/owl/trans/OtterfierService.owl#OtterfierService
  (if (and
        (applicable-operator (www.mathweb.org/owl/trans/OtterfierService.owl#OtterfierService <atp_result>  <new_result>))
        (or
         (~ (exact-type-of-object <new_result> OWL-FOBrFPResult))
         )))
  (then sub-goal))


 (setf (current-problem)
            (create-problem
              (name www.foo.org/owl/queries/NDProofQuery1.owl)
              (objects 
                (www.foo.org/owl/queries/NDProofQuery1.owl#cnf_problem12345 OWL-TstpCNFProblem)
                (www.foo.org/owl/queries/NDProofQuery1.owl#atp_result OWL-FOATPResult)
             )
              (state (and   (bound www.foo.org/owl/queries/NDProofQuery1.owl#cnf_problem12345)
              ))
              (goal  (and   (bound www.foo.org/owl/queries/NDProofQuery1.owl#atp_result)
                (resultFor www.foo.org/owl/queries/NDProofQuery1.owl#atp_result www.foo.org/owl/queries/NDProofQuery1.owl#cnf_problem12345)
))))


;; (setf (current-problem)
;;       (create-problem
;; ;;       (name foo)
;;        (objects
;; 	(fofproblem OWL-TSTPFOFPROBLEM)
;; 	(ndProof OWL-TwegaNDPROOF)
;; 	)
;;        (state
;; 	(and
;; 	 (bound fofproblem)
;; 	 )
;; 	)
;;        (goal
;; 	(and
;; 	 (bound ndProof)
;; 	 (proofOf ndProof fofproblem)
;; 	 ;;	 (bound atpres3)
;; 	 ;;	 (resultFor atpres3 fofproblem)
;; 	 )
;; 	)))




