#!/bin/sh

# These uninitialized vars are initialized by the installer and must start in
# column 1
J2SE_VER=1.4.2_04
J2SE_INSTALL_DIR=/import/monster2/project/java/j2sdk1.4.2_04
UNINSTALLDIR=$J2SE_INSTALL_DIR/_uninst
LOGFILE=$J2SE_INSTALL_DIR/uninstall.log
RM=/bin/rm

if [ ! -f "$LOGFILE" ] ; then
	/bin/touch "$LOGFILE"
fi

echo "--------------------" >> "$LOGFILE"
echo "Uninstallation date: `date`" >> "$LOGFILE"

if [ ! -x $RM ] ; then
	echo "ERROR: Cannot remove.  Your $RM utility is not executable or doesn't exist."
fi

if [ -d $J2SE_INSTALL_DIR ] ; then
	echo "Uninstalling J2SDK $J2SE_VER ..." >> "$LOGFILE"
	/bin/rm -rf "$J2SE_INSTALL_DIR" >> "$LOGFILE" 2>&1
else
	echo "$J2SE_INSTALL_DIR doesn't exist!" 
	echo "$J2SE_INSTALL_DIR doesn't exist!" >> "$LOGFILE"
fi

if [ -x "$LOGFILE" ] ; then
	echo "The uninstallation is completed." >> "$LOGFILE"
	echo `date` >> "$LOGFILE"
fi

if [ -d "$UNINSTALLDIR" ] ; then
	/bin/rm -rf "$UNINSTALLDIR" > /dev/null 2>&1
fi

exit 0
